aboutsummaryrefslogtreecommitdiffstats
path: root/scripts
diff options
context:
space:
mode:
authorFelix Fietkau <nbd@openwrt.org>2016-01-31 23:29:07 +0000
committerFelix Fietkau <nbd@openwrt.org>2016-01-31 23:29:07 +0000
commit695d68c07de840d904af5cd9dac6cb4984814e72 (patch)
treefc89905a660fdec3686d88535bd493fc0f4e8773 /scripts
parentc07b5ec4fc3e4d61775cfc2ed473a00e2752fe4a (diff)
downloadmaster-187ad058-695d68c07de840d904af5cd9dac6cb4984814e72.tar.gz
master-187ad058-695d68c07de840d904af5cd9dac6cb4984814e72.tar.bz2
master-187ad058-695d68c07de840d904af5cd9dac6cb4984814e72.zip
build: introduce SOURCE_DATE_EPOCH variable
SOURCE_DATE_EPOCH is the date of the last modified file using git/svn as date source. See https://reproducible-builds.org/specs/source-date-epoch/ Signed-off-by: Alexander Couzens <lynxis@fe80.eu> Signed-off-by: Felix Fietkau <nbd@openwrt.org> git-svn-id: svn://svn.openwrt.org/openwrt/trunk@48584 3c298f89-4303-0410-b956-a3cf2f4a3e73
Diffstat (limited to 'scripts')
-rwxr-xr-xscripts/get_source_date_epoch.sh31
1 files changed, 31 insertions, 0 deletions
diff --git a/scripts/get_source_date_epoch.sh b/scripts/get_source_date_epoch.sh
new file mode 100755
index 0000000000..b8efb761d0
--- /dev/null
+++ b/scripts/get_source_date_epoch.sh
@@ -0,0 +1,31 @@
+#!/usr/bin/env bash
+export LANG=C
+export LC_ALL=C
+[ -n "$TOPDIR" ] && cd $TOPDIR
+
+try_version() {
+ [ -f version.date ] || return 1
+ SOURCE_DATE_EPOCH="$(cat version.date)"
+ [ -n "$SOURCE_DATE_EPOCH" ]
+}
+
+try_svn() {
+ [ -d .svn ] || return 1
+ SOURCE_DATE_EPOCH="$(./scripts/portable_date.sh "$(svn info --show-item last-changed-date)" +%s)"
+ [ -n "$SOURCE_DATE_EPOCH" ]
+}
+
+try_git() {
+ [ -e .git ] || return 1
+ SOURCE_DATE_EPOCH="$(git log -1 --format=format:%ct)"
+ [ -n "$SOURCE_DATE_EPOCH" ]
+}
+
+try_hg() {
+ [ -d .hg ] || return 1
+ SOURCE_DATE_EPOCH=""
+ [ -n "$SOURCE_DATE_EPOCH" ]
+}
+
+try_version || try_svn || try_git || try_hg || SOURCE_DATE_EPOCH=""
+echo "$SOURCE_DATE_EPOCH"